(function () {
    "use strict";

    angular.module('core').controller('feedbackConsumidorController', controller);
    controller.$inject = ['$scope', '$timeout', 'feedbackConsumidorService'];

    function controller($scope, $timeout, feedbackConsumidorService) {
        $scope.initializeLayout('Feedbacks dos Consumidores');

        //[Inicializa objetos]
        $scope.state = {
            data: [],
            carregando: false,
            vazio: false,
            count: 0,
            filtro: {
                ativo: false,
                args: {
                    chaves: '',
                    chavesVendedor: null,
                    chavesFilial: null,
                    chavesCampanhaCRM: null,
                    chavesProduto: null,
                    clienteID: null,
                    vendedorID: null,
                    filialID: null,
                    campanhaCRMID: null,
                    produtoID: null,
                    indicaVendedor: null,
                    indicaFilial: null,
                    indicaCampanhaCRM: null,
                    indicaProduto: null,
                    sortExpression: '',
                    skip: 0,
                    take: 20
                }
            }
        };

        //[Inicializa funcões]
        $scope.initialize = function () {
            $scope.refresh();
        };

        $scope.getAll = function () {
            $scope.state.filtro.args.skip = 0;
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            feedbackConsumidorService
                .getAll($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            angular.copy(angular.fromJson(response.Data), $scope.state.data);
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = ($scope.state.data == 0);
                    },
                    function (_error) {
                        $scope.state.carregando = false;
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.count = function () {
            feedbackConsumidorService
                .count($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.count = response.Data;
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.getMore = function () {
            $scope.state.filtro.args.skip += $scope.state.filtro.args.take;
            feedbackConsumidorService
                .getAll($scope.state.filtro.args)
                .then(
                    function (response) {
                        if (response.Status < 0) {
                            $scope.tools.toastr.error(response.Message, 'Serviço');
                            console.error(response.Exception);
                        } else {
                            $scope.state.data = $scope.state.data.concat(response.Data);
                        }
                    },
                    function (_error) {
                        $scope.tools.toastr.error('Não foi possível conectar com o(s) servidor(es)');
                        console.error(_error);
                    }
                );
        };
        $scope.refresh = function () {
            $scope.getAll();
            $scope.count();
        };

        $scope.clearFilter = function () {
            $scope.state.filtro.args.chaves = '';
            $scope.state.filtro.args.chavesVendedor = null;
            $scope.state.filtro.args.chavesFilial = null;
            $scope.state.filtro.args.chavesCampanhaCRM = null;
            $scope.state.filtro.args.chavesProduto = null;
            $scope.state.filtro.args.ativo = null;
            $scope.state.filtro.args.clienteID = null;
            $scope.state.filtro.args.vendedorID = null;
            $scope.state.filtro.args.filialID = null;
            $scope.state.filtro.args.campanhaCRMID = null;
            $scope.state.filtro.args.produtoID = null;
            $scope.state.filtro.args.indicaVendedor = null;
            $scope.state.filtro.args.indicaFilial = null;
            $scope.state.filtro.args.indicaCampanhaCRM = null;
            $scope.state.filtro.args.indicaProduto = null;

            $scope.refresh();
        };
        $scope.toggleFilter = function () {
            $scope.state.filtro.ativo = !$scope.state.filtro.ativo;
        };

        /*Inicializa funções*/
        $scope.initialize();

    }

})();